/* commandir_tcp_sample.c
 * Sample code to interface to commandird daemon over network
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

unsigned char networkName[160];
/* unsigned char localhostPtr[] = "127.0.0.1"; defined in libtcp_client */
extern unsigned char localhostPtr[];

unsigned char testCommand1[] = "commandir_record -d -g100000\0\0";
unsigned char testCommand2[] = "commandir_record_stop\0\0";
unsigned char testCommand3[] = "commandir_record -o\0\0";
unsigned char testCommand4[] = "commandir_record\0\0";
unsigned char testCommand5[] = "commandir_send -bff -r 0000 0074 0017 0000 0020 0021 0020 0020 0020 0021 0020 0020 0020 0021 0020 0020 0020 0021 0020 0020 0040 0020 0020 0041 003F 0041 0020\0\0";

void networkWaitForResponse_DisplayLines(int milliseconds);

int main(int argc, char **argv)
{

  // networkName is name of host to connect; localhost by default
  strncpy(networkName, localhostPtr, strlen(localhostPtr));

  /* Network Connect */
  if(!networkClientConnect(networkName)) {
    printf("Unable to connect to %s\n", networkName);
    return -1;
  }
  
  /* Create Commands to send to commandird (same as Pipe commands) */
  printf("Displaying results from tcp:\n");

  // In a custom program, networkWaitForResponse() can be used or modified.
  networkWaitForResponse_DisplayLines(1000);
  printf("Sending '%s'...\n", testCommand1);
  networkClientSend(testCommand1, strlen(testCommand1)+1);

  networkWaitForResponse_DisplayLines(5000);
  printf("Sending '%s'...\n", testCommand2);
  networkClientSend(testCommand2, strlen(testCommand2)+1);

  networkWaitForResponse_DisplayLines(5000);
  printf("Sending '%s'...\n", testCommand3);
  networkClientSend(testCommand3, strlen(testCommand3)+1);

  networkWaitForResponse_DisplayLines(5000);
  printf("Sending '%s'...\n", testCommand4);
  networkClientSend(testCommand4, strlen(testCommand4)+1);

  networkWaitForResponse_DisplayLines(5000);
  printf("Sending '%s'...\n", testCommand5);
  networkClientSend(testCommand5, strlen(testCommand5)+1);

  networkWaitForResponse_DisplayLines(500);
  networkClientClose();
}


void networkWaitForResponse_DisplayLines(int milliseconds)
{
  int msCount = 0;
  int currentCount;
  char retBuf[1024];
  int countResponses = 1;
  
  while(msCount < milliseconds)
  {
    currentCount = networkClientRecv(retBuf, 1024);
    if(currentCount > 0)
    {
      retBuf[currentCount] = '\0';
      printf("Response '%d' from commandird: %s\n", countResponses++, retBuf); 
    }
    if( (currentCount < -1) && (currentCount != EWOULDBLOCK) && (currentCount != EAGAIN) )
    {
      printf("Connection closed (%d)\n", currentCount);
      return;
    }
#ifdef WIN
    Sleep(5);
#else
    usleep(5000);
#endif
    msCount += 5;
  }
}

